.include "nes.inc"

.include "pently.inc"

.importzp temp
.importzp tv_type
.importzp ppustrings_ready, ppustrings_count
.importzp ntd_stream_ptr
.importzp ppu_var_scroll_x, ppu_var_scroll_y, ppu_var_ctrl, ppu_var_mask
.importzp pad_1_keys, pad_2_keys, pad_1_axlr, pad_2_axlr
.importzp stack_tos
.import ppu_oam, ppu_buffer

.import ppu_vsync, ppu_set_addr, pads_read, ppu_vsync_forced_blank
.import ppustrings_init, ppustrings_init_with_callback
.import ppustrings_new_string, ppustrings_finish_string, ppustrings_write_run
.import bagel_bulk_upload
.import ntd_decode


.import controller_music, button_logger_activity, the42melody, bagel_demo
.export main

pad_1_inv_prev = pad_1_axlr
pad_2_inv_prev = pad_2_axlr

.import stack_restoreState, stack_saveState, stack_dup, stack_drop
.import stack_multiply, stack_divide, stack_pushZero
.import stack_2dup, stack_2drop, stack_2plus, stack_udslashmod
.import stack_increment
.import rng_stepByte, rng_stepWord

.import ppustrings_nmi_kernel

.segment "ZEROPAGE": zeropage
  activity_selection:    .res 1

.segment "CODE"

hello_world_string:
  .byte "Whatever is true, honorable, just, lovely, commendable "
  .byte "-- if there is any moral excellence, any praise -- "
  .byte "dwell on these things.", $00

.proc main
  jsr ppu_vsync_forced_blank
  ;,; ldy #<$0000
  tya  ;,; lda #>$0000
  jsr ppu_set_addr

  ldy #<menu_chr
  lda #>menu_chr
  jsr bagel_bulk_upload

  ldy #<$0100
  lda #>$0100
  jsr ppu_set_addr

  ldy #<font_chr
  lda #>font_chr
  jsr bagel_bulk_upload
  jsr bagel_bulk_upload

  ldy #<$2000
  lda #>$2000
  jsr ppu_set_addr

  txa
  pha
    ldy #$100-192
    @__loop1892:
      ldx #1
      @__loop1893:
        stx PPU_DATA
        inx
        cpx #1+5
      bcc @__loop1893
      iny
    bne @__loop1892
    ;,; ldy #$00
    ldx #$100-64
    @__loop1894:
      sty PPU_DATA
      inx
    bne @__loop1894
  pla
  tax

  ldy #<the42melody_nam
  lda #>the42melody_nam
  jsr ntd_decode
  
  ldy #<$20c0
  lda #>$20c0
  jsr ppu_set_addr
  ldy #<menu_menu_nam
  lda #>menu_menu_nam
  jsr ntd_decode
  
  ldy #<$3fe0
  lda #>$3fe0
  jsr ppu_set_addr
  lda #$20
  sta PPU_DATA
  lda #$2c
  sta PPU_DATA
  lda #$3c
  sta PPU_DATA
  lda #$0f
  sta PPU_DATA

  lda #0
  sta activity_selection

  jsr pently_init
  lda #0
  jsr pently_start_music

main_loop:
  jsr ppu_vsync
  jsr copy_keys_to_prev
  jsr pads_read
  lda pad_1_keys
  and pad_1_inv_prev
  and #BUTTON_A
  beq not_activity_1
    jsr pently_init
    ldy activity_selection
    lda #>(main-1)
    pha
    lda #<(main-1)
    pha
    jmp do_activity
  not_activity_1:

  lda pad_1_keys
  and pad_1_inv_prev
  and #BUTTON_DOWN
  beq not_down
    ldy activity_selection
    iny
    cpy #4
    bcc no_down_warp
      ldy #0
    no_down_warp:
    sty activity_selection
  not_down:

  lda pad_1_keys
  and pad_1_inv_prev
  and #BUTTON_UP
  beq not_up
    ldy activity_selection
    dey
    bpl no_up_warp
      ldy #3
    no_up_warp:
    sty activity_selection
  not_up:
  
  lda #VBLANK_NMI|VRAM_DOWN
  sta PPU_CTRL
  ldy #<$2104
  lda #>$2104
  jsr ppu_set_addr
  lda #$20
  ldy #7
  string1342:
    sta PPU_DATA
    dey
  bne string1342
  
  lda activity_selection
  asl
  asl
  asl
  asl
  asl
  asl
  clc
  adc #<$2104
  tay
  lda #>$2104
  jsr ppu_set_addr
  lda #$1f
  sta PPU_DATA

  ldx #0
  ldy #0
  sty PPU_SCROLL
  sty PPU_SCROLL
  lda #VBLANK_NMI|NT_2000
  sta PPU_CTRL
  lda #BG_ON
  sta PPU_MASK
  
  jsr pently_update
jmp main_loop
.endproc

.proc stack_div_test
loop:
  jsr ppu_vsync
  ldy #$1a
  lda $ee
  cmp $e4
  beq test1_ok
    ldy #$16
  test1_ok:
  lda $ef
  cmp $e5
  beq test2_ok
    ldy #$16
  test2_ok:
  ldy #<$3fe0
  lda #>$3fe0
  jsr ppu_set_addr
  sty PPU_DATA
  ldy #$00
  tya
  jsr ppu_set_addr

  jsr stack_restoreState
  jsr rng_stepWord
  jsr stack_dup
  jsr rng_stepWord
  jsr stack_2dup
  jsr stack_multiply
  jsr stack_2dup
  jsr stack_dup
  ldy 8,x
  lda 9,x
  jsr stack_udslashmod
  inx
  inx
  jsr stack_dup
  jsr stack_2drop
  jsr stack_2drop
  jsr stack_2drop
  jsr stack_saveState
jmp loop
.endproc

.proc copy_keys_to_prev
  lda pad_1_keys
  eor #$ff
  sta pad_1_inv_prev
  lda pad_2_keys
  eor #$ff
  sta pad_2_inv_prev
rts
.endproc

.proc do_activity
  lda activity_table_hi, y
  pha
  lda activity_table_lo, y
  pha
no_activity:
rts

activity_table_lo:
  .byte <(button_logger_activity-1), <(controller_music-1), <(no_activity-1)
  .byte <(the42melody_wrapper-1)
activity_table_hi:
  .byte >(button_logger_activity-1), >(controller_music-1), >(no_activity-1)
  .byte >(the42melody_wrapper-1)
.endproc

.proc the42melody_wrapper
  ldy #<$3fe0
  lda #>$3fe0
  jsr ppu_set_addr
  lda #$0f
  sta PPU_DATA
  lda #$0f
  sta PPU_DATA
  lda #$0f
  sta PPU_DATA
  lda #$30
  sta PPU_DATA

  ldx #0
  ldy #0
  sty PPU_SCROLL
  sty PPU_SCROLL
  lda #VBLANK_NMI|NT_2400
  sta PPU_CTRL
  lda #BG_ON
  sta PPU_MASK
  loop:
    jsr the42melody
    jsr pads_read
    lda pad_1_keys
    ora pad_2_keys
  beq loop
rts
.endproc

.segment "RODATA"

font_chr:
  .incbin "obj/font.chr.bagel"
windows_chr:
  .incbin "obj/windows.chr.bagel"

menu_chr:
  .incbin "obj/menu-bg.chr.bagel"

the42melody_nam:
  .incbin "src/screens/42-text.nam.ntd"
  
menu_menu_nam:
  .incbin "src/screens/menu-menu.ntd"
